/*
 * ##################################################### Start MainSite Addon #####################################################
 */

MainSite.prototype.addProductTopNavMenuItems = function() {
  this.pages['LoginPage'] = new LoginPage();

  this.menu.insertAfter(new MenuItem('change_settings', 'NetworkSettingsPage'), this.menu.device_status);
  this.pages['NetworkSettingsPage'] = new NetworkSettingsPage();
  this.pages['NetworkSettingsPage'].ipSettingsFormEnabled = true;
  this.pages['NetworkSettingsPage'].ntpSettingsFormEnabled = true;

  this.headerMenu = ((new Menu(new MenuItem('change_password', 'ChangePasswordPage'))));
  this.pages['ChangePasswordPage'] = new ChangePasswordPage();

  this.headerMenu.add(new MenuItem('logout', 'LogoutPage'));
  this.pages['LogoutPage'] = new LogoutPage();

  this.menu.insertAfter(new MenuItem('data_logger', 'DataLoggerPage'), this.menu.device_status);
  this.pages['DataLoggerPage'] = new DataLoggerPage();
  
  if (location.hash == '#EnableKnxIpProxyPage') {
    this.menu.insertAfter(new MenuItem('knx_group_communication_proxy', 'KnxIpProxyPage'), this.menu.device_status);
    this.pages['KnxIpProxyPage'] = new KnxIpProxyPage();
  }
}

/*
 * ##################################################### End MainSite Addon #####################################################
 */

/*
 * ##################################################### Start StatusPage Addon #####################################################
 */
StatusPage.prototype.portalConnectionState = undefined;
StatusPage.prototype.appendDOMFragmentSda_portalConnectionState = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('sda_portal_connection') + ': '));
  parentElement.appendChild(elem);
  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.portalConnectionState == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.portalConnectionState.ConnectionStatus[1] + ' (' + thisClass.portalConnectionState.ConnectionStatus[0] + ')';
      if (thisClass.portalConnectionState.ConnectionStatus[0] != 0) {
        textNode.nodeValue += ' - ' + i18n.translate('last_connect_error') + ': ' + thisClass.portalConnectionState.ConnectionError[1] + ' (' + thisClass.portalConnectionState.ConnectionError[0] + ')';
      }
    }
  );

  if (!mainSite.timer.getPortalConnectionState) {
    mainSite.timer.getPortalConnectionState = new TimedRequest(INTERVAL.MINUTE, 'getPortalConnectionState', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.portalConnectionState = response.data;
      }
    }, thisClass);
    mainSite.timer.getPortalConnectionState.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getPortalConnectionState.oneShot();
  mainSite.timer.getPortalConnectionState.resetTimeout();
}

StatusPage.prototype.buildInfo = undefined;
StatusPage.prototype.appendDOMFragmentSda_buildinfoTo = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('sda_software') + ':'));
  parentElement.appendChild(elem);

  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.buildInfo == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.buildInfo.buildInfo;
    }
  );

  if (!mainSite.timer.getBuildInfo) {
    mainSite.timer.getBuildInfo = new TimedRequest(INTERVAL.MINUTE, 'getBuildInfo', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.buildInfo = response.data;
      }
    }, thisClass);
    mainSite.timer.getBuildInfo.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getBuildInfo.oneShot();
  mainSite.timer.getBuildInfo.resetTimeout();
}

StatusPage.prototype.connectorID = undefined;
StatusPage.prototype.appendDOMFragmentServiceIdTo = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('service_id') + ':'));
  parentElement.appendChild(elem)
  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.connectorID == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.connectorID.connectorid;
    }
  );

  if (!mainSite.timer.getConnectorID) {
    mainSite.timer.getConnectorID = new TimedRequest(INTERVAL.MINUTE, 'getConnectorID', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.connectorID = response.data;
      }
    }, thisClass);
    mainSite.timer.getConnectorID.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getConnectorID.oneShot();
  mainSite.timer.getConnectorID.resetTimeout();
}

StatusPage.prototype.appendDOMFragmentCOInfosTo = function(parentElement) {
  var span = document.createElement('span');
  span.setAttribute('hidden', '');
  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        span.removeAttribute('hidden');
      } else {
        span.setAttribute('hidden', '');
      }
    }
  );
  parentElement.appendChild(span);
  parentElement = span;
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('grant_access_states') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));

  var grandRemoteAccessCO = 2;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grandRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));

  var grandResidentsRemoteAccessCO = 4;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grandResidentsRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));

  var grandInstallersRemoteAccessCO = 6;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grandInstallersRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));

  if (StatusPage.prototype.disableQuickConnect && StatusPage.prototype.disableQuickConnect === true) {
  } else {
  
  
  }

  parentElement.appendChild(document.createElement('br'));

  elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('connection_states') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));

  var statePortalConnectionCO = 20;
  this.appendDOMFragmentKimCoInfoTo(parentElement, statePortalConnectionCO);

  parentElement.appendChild(document.createElement('br'));

  var stateAnyRemoteConnectionCO = 21;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateAnyRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));

  var stateResidentsRemoteConnectionCO = 22;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateResidentsRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));
  var stateInstallersRemoteConnectionCO = 23;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateInstallersRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));

  if (StatusPage.prototype.disableQuickConnect && StatusPage.prototype.disableQuickConnect === true) {
  } else {
  
  
  }

  parentElement.appendChild(document.createElement('br'));

  elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('general_information') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));

  var errorIndicationCO = 30;
  this.appendDOMFragmentKimCoInfoTo(parentElement, errorIndicationCO);

  parentElement.appendChild(document.createElement('br'));
  var portalConnectionInfoCO = 31;
  this.appendDOMFragmentKimCoInfoTo(parentElement, portalConnectionInfoCO);

  parentElement.appendChild(document.createElement('br'));
  var connectionErrorInfoCO = 32;
  this.appendDOMFragmentKimCoInfoTo(parentElement, connectionErrorInfoCO);

  parentElement.appendChild(document.createElement('br'));
  var thisClass = this;

}

StatusPage.prototype.prepareAppInfo = function(divAppInfomation) {
  headerAppInformation = document.createElement('h3');
  headerAppInformation.setAttribute('class', 'h3');
  headerAppInformation.appendChild(document.createTextNode(i18n.translate('sda_application_information')));
  divAppInfomation.appendChild(headerAppInformation);

  var fragmentAppState = document.createElement('span');
  fragmentAppState.setAttribute('hidden', '');
  divAppInfomation.appendChild(fragmentAppState);
  this.appendDOMFragmentAppStateTo(fragmentAppState);

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        fragmentAppState.removeAttribute('hidden');
      } else {
        fragmentAppState.setAttribute('hidden', '');
      }
    }
  );

  this.appendDOMFragmentSda_portalConnectionState(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentSda_buildinfoTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentServiceIdTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentCOInfosTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));
}

StatusPage.prototype.updateCO = function(span, textNode, currentCO) {
  switch (currentCO.id) {
    case 31:
      textNode.nodeValue = i18n.translate(currentCO.value);
      if (currentCO.value == 'Connected' || currentCO.value == 'True') {
        span.setAttribute('class', 'text--success');
      } else if (currentCO.value) {
        span.setAttribute('class', 'text--error');
      }
      break;
    case 32:
      textNode.nodeValue = i18n.translate(currentCO.value);
      if (currentCO.value == 'None' || currentCO.value == 'False') {
        span.setAttribute('class', 'text--success');
      } else if (currentCO.value) {
        span.setAttribute('class', 'text--error');
      }
      break;
    default:
      if (currentCO.value == '1') {
        span.setAttribute('class', 'text--success');
        textNode.nodeValue = i18n.translate('True');
      } else if (currentCO.value == '0') {
        span.setAttribute('class', 'text--error');
        textNode.nodeValue = i18n.translate('False');
      }
      break;
  }
}
/*
 * ##################################################### End StatusPage Addon #####################################################
 */
/*###################################################### www/web/DataLogger.js #############################################*/
/*
 * ##################################################### Start DataLoggerPage #####################################################
 */
function DataLoggerPage() {
  this.dataLoggerArchiveEntries = undefined;
  this.dataLoggerArchiveEntriesUpdated = false;
  this.dataLoggerArchiveEntriesHash = undefined;

  if (!(this instanceof DataLoggerPage)) {
    return new DataLoggerPage();
  }
  PageTemplate.call(this);
  var thisClass = this;

  this.prepare = function() {
    if (!thisClass.contentSection) {
      thisClass.contentSection = document.createElement('div');
      var header = document.createElement('h3');
      header.setAttribute('class', 'h3');
      header.appendChild(document.createTextNode(i18n.translate('data_logger')));
      thisClass.contentSection.appendChild(header);
      thisClass.contentSection.appendChild(document.createTextNode(i18n.translate('data_logger_configuration_note')));
      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createTextNode(i18n.translate('sd_card_status') + ': '));
      var sdState = document.createTextNode('');
      thisClass.contentSection.appendChild(sdState);

      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createElement('br'));

      var divSpinnerWaitForData = document.createElement('div');
      divSpinnerWaitForData.setAttribute('class', 'spinner');
      divSpinnerWaitForData.setAttribute('id', 'WaitForData');
      thisClass.contentSection.appendChild(divSpinnerWaitForData);
 
      var archiveHeader = document.createElement('h3');
      archiveHeader.appendChild(document.createTextNode(i18n.translate('content')));
      archiveHeader.setAttribute('id', 'ArchiveHeader');
      archiveHeader.setAttribute('hidden', '');
      thisClass.contentSection.appendChild(archiveHeader);

      var dataLoggerArchiveEntriesList = document.createElement('div');
      dataLoggerArchiveEntriesList.setAttribute('container', '');
      dataLoggerArchiveEntriesList.setAttribute('id', 'DataLoggerArchiveEntries');
      thisClass.contentSection.appendChild(dataLoggerArchiveEntriesList);
      thisClass.contentSection.appendChild(document.createElement('br'));

      thisClass.dataBindings.push(function() {
        if (thisClass.dataLoggerArchiveEntriesUpdated === undefined || thisClass.dataLoggerArchiveEntriesUpdated) {
          thisClass.dataLoggerArchiveEntriesUpdated = false;
          var newArchiveEntries = document.createElement('div');
          newArchiveEntries.setAttribute('container', '');
          newArchiveEntries.setAttribute('id', 'DataLoggerArchiveEntries');
          if (thisClass.dataLoggerArchiveEntries) {
            thisClass.addArchiveColumns(newArchiveEntries);
            document.getElementById('WaitForData').setAttribute('hidden', '');
            document.getElementById('ArchiveHeader').removeAttribute('hidden');
          } else {
            document.getElementById('WaitForData').removeAttribute('hidden');
            document.getElementById('ArchiveHeader').setAttribute('hidden', '');
          }
          var oldNode = document.getElementById('DataLoggerArchiveEntries');
          var parent = oldNode.parentNode;
          parent.replaceChild(newArchiveEntries, oldNode);
        }
        if (mainSite.deviceInfo.SdCardPresent) {
          sdState.nodeValue = i18n.translate('sd_card_status_active').replace(/SDCARDUSAGE|SDCARDSIZE/gi,
              function(subst) {
                switch (subst) {
                  case 'SDCARDUSAGE':
                    return mainSite.deviceInfo.SdCardUsage;
                  case 'SDCARDSIZE':
                    return mainSite.deviceInfo.SdCardSize;
                }
              }) + ' ';
        } else {
          sdState.nodeValue = i18n.translate("sd_card_status_not_present");
        }
      });
    }
    mainSite.main.appendChild(thisClass.contentSection);
    thisClass.requestData();
    thisClass.update();
    thisClass.setFocus();
  }

  this.addArchiveColumns = function(parent) {
    if (thisClass.dataLoggerArchiveEntries) {
      thisClass.dataLoggerArchiveEntries.years.sort(function(a, b) {
          if (a.name < b.name) {
            return -1;
          }
          if (a.name > b.name) {
            return 1;
          }
          return 0;
        });
      thisClass.dataLoggerArchiveEntries.years.forEach(function(year_entry) {
        var year = document.createElement('div');
        year.setAttribute('row', '');
        year.setAttribute('id', 'year'+year_entry.year);
        var yearHeader = document.createElement('div');
        yearHeader.setAttribute('column', '4');
        var yearName = document.createElement('h4');
        var expandYearLink = createGlyphIconElement('a', 'plus', 'black');
        expandYearLink.setAttribute('style', 'padding-left:1.2em; font-size:1.5em');
        expandYearLink.appendChild(document.createTextNode(year_entry.year));
        expandYearLink.pseudoStyle('before', 'font-size', '0.8em');
        yearName.appendChild(expandYearLink);
        yearHeader.appendChild(yearName);
        year.appendChild(yearHeader);
        var months = document.createElement('div');
        months.setAttribute('container', '');
        months.setAttribute('id', 'month-'+year_entry.year);
        months.setAttribute('hidden', '');
        expandYearLink.onclick = function() {
          var thisMonths = months;
          if (thisMonths.hasAttribute('hidden')) {
            thisMonths.removeAttribute('hidden');
            this.classList.remove('plus');
            this.classList.add('minus');
          } else {
            thisMonths.setAttribute('hidden', '');
            this.classList.remove('minus');
            this.classList.add('plus');
          }
          this.blur();
        }
        year_entry.months.sort(function(a, b) {
          if (a.name < b.name) {
            return -1;
          }
          if (a.name > b.name) {
            return 1;
          }
          return 0;
        });
        year_entry.months.reverse();
        var year_size = 0;
        year_entry.months.forEach(function(month_entry) {
          year_size += month_entry.size;
          if (month_entry.size > 0) {
            var month = document.createElement('div');
            month.setAttribute('row', '');
            month.setAttribute('id', 'month'+ month_entry.name);
            var monthSpacer = document.createElement('div');
            monthSpacer.setAttribute('column', '1');
            var monthHeader = document.createElement('div');
            monthHeader.setAttribute('column', '2');
            var monthDownload = document.createElement('div');
            monthDownload.setAttribute('column', '2');
            var monthName = document.createElement('b')
            var expandMonthLink = createGlyphIconElement('a', 'plus', 'black');
            expandMonthLink.setAttribute('style', 'padding-left:1.25em; font-size:1em');
            expandMonthLink.appendChild(document.createTextNode(month_entry.name));
            expandMonthLink.pseudoStyle('before', 'font-size', '0.8em');
            expandMonthLink.pseudoStyle('before', 'position', 'relative');
            monthName.appendChild(expandMonthLink);
            var monthDownloadContent = document.createElement('b');
            monthDownloadContent.appendChild(document.createTextNode(thisClass.convertFileSize(month_entry.size)));
            monthDownloadContent.setAttribute('style', 'padding-left:2.7em');
            monthHeader.appendChild(monthName);
            monthDownload.appendChild(monthDownloadContent);
            month.appendChild(monthSpacer);
            month.appendChild(monthHeader);
            month.appendChild(monthDownload);
            var days = document.createElement('div');
            days.setAttribute('container', '');
            days.setAttribute('id', 'days-'+month_entry.name);
            days.setAttribute('hidden', '');
            expandMonthLink.onclick = function() {
              var thisDays = days;
              if (thisDays.hasAttribute('hidden')) {
                thisDays.removeAttribute('hidden');
                this.classList.remove('plus');
                this.classList.add('minus');
              } else {
                thisDays.setAttribute('hidden', '');
                this.classList.remove('minus');
                this.classList.add('plus');
              }
              this.blur();
            }
            months.appendChild(month);
            months.appendChild(days);
            month_entry.days.sort(function(a, b) {
              if (a.path < b.path) {
                return -1;
              }
              if (a.path > b.path) {
                return 1;
              }
              return 0;
            });
            month_entry.days.reverse();
            month_entry.days.forEach(function(day_entry) {
              var dayname = day_entry.path.substring(day_entry.path.indexOf(year_entry.year)).replace(/\//g, '-');
              var files = document.createElement('div');
              files.setAttribute('container', '');
              files.setAttribute('id', 'files-'+dayname);
              day_entry.files.sort(function(a, b) {
                if (a.name < b.name) {
                  return -1;
                }
                if (a.name > b.name) {
                  return 1;
                }
                return 0;
              });
              day_entry.files.forEach(function(file_entry) {
                var file = document.createElement('div');
                file.setAttribute('row', '');
                var fileSpacer = document.createElement('div');
                fileSpacer.setAttribute('column', '3');
                var fileName = document.createElement('div');
                fileName.setAttribute('column', '2');
                var fileDownload = document.createElement('div');
                fileDownload.setAttribute('column', '2');
                fileName.appendChild(document.createElement('p'));
                fileName.firstChild.appendChild(document.createTextNode(file_entry.name));
                fileName.firstChild.setAttribute('style', 'padding-left:0.5em');
                var fileLink = createGlyphIconElement('a', 'download', 'black');
                fileLink.setAttribute('style', 'margin-left: 2em; padding-left:0em; font-size:1em');
                fileLink.pseudoStyle('before', 'font-size', '1.2em');
                fileLink.pseudoStyle('before', 'position', 'relative');
                fileLink.appendChild(document.createTextNode(thisClass.convertFileSize(file_entry.size)));
                fileDownload.appendChild(fileLink);
                fileLink.onclick = function() {
                    var dialog = new ModalSpinnerDialog(i18n.translate('data_logger') + ' - ' + i18n.translate('download_logs'), i18n.translate('download_logs_started'));
                    dialog.prepare();
                    this.id = 'DownloadLoggerFile';
                    thisClass.downloadLoggerFile(day_entry.path+'/'+file_entry.name, dialog);
                }
                file.appendChild(fileSpacer);
                file.appendChild(fileName);
                file.appendChild(fileDownload);
                files.appendChild(file);
              });
              days.appendChild(files);
            });
          }
        });
        if (year_size > 0) {
          parent.appendChild(year);
          parent.appendChild(months);
        }
      });
    }
  }

  this.convertFileSize = function(size) {
    if (size < 2) {
      return size + " " + i18n.translate('t_byte');
    } else if (size < 1024) {
      return size + " " + i18n.translate('t_bytes');
    } else if (size < 2048000) {
      return (size/1024).toFixed(1) + " " + i18n.translate('t_kbyte');
    } else {
      return (size/1024/1024).toFixed(1) + " " + i18n.translate('t_mbyte');
    }
  }
  
  this.downloadLoggerFile = function(filename, dialog) {
    IscWebService('getDownloadLink', {'filename' : filename}, function(response) {
      if (response == undefined) {                                                  
        DisplayError(response);
        return;
      }
      if (response.error) {
        DisplayError(response);
        return;
      }
      var link = document.createElement('a');
      var filepath = response.data.URL.split('/');
      var name = filepath[filepath.length -1];
      link.setAttribute("href", response.data.URL);
      link.appendChild(document.createTextNode(i18n.translate('click_here')));
      link.setAttribute("download", name);
      dialog.showDone(i18n.translate('download_logs_finished'));
      dialog.modalBody.appendChild(link);
      link.click();
    });
  }  

  this.setDataLoggerArchiveEntries = function(response) {
    if (response && response.data && response.data.years.length) {
      var newHash = forge.md.md5.create().update(response.data).digest().toHex();
      thisClass.dataLoggerArchiveEntriesUpdated = !(thisClass.dataLoggerArchiveEntriesHash == newHash);
      if (thisClass.dataLoggerArchiveEntriesUpdated) {
        thisClass.dataLoggerArchiveEntriesHash = newHash;
        thisClass.dataLoggerArchiveEntries = response.data;
      }
    } else {
      // no data received
      thisClass.dataLoggerArchiveEntriesUpdated = true;
      thisClass.dataLoggerArchiveEntriesHash = undefined;
      thisClass.dataLoggerArchiveEntries = undefined;
    }
  }

  this.setFocus = function() {
  };

  this.requestData = function() {
    mainSite.timer.getDeviceInfo.oneShot();

    if (!mainSite.timer.getDataLoggerArchiveEntries) {
      mainSite.timer.getDataLoggerArchiveEntries = new TimedRequest(INTERVAL.MINUTE, 'getDataLoggerArchiveEntries', '', thisClass.setDataLoggerArchiveEntries, thisClass);
    } else {
      mainSite.timer.getDataLoggerArchiveEntries.timeout = INTERVAL.MINUTE;
    }
    mainSite.timer.getDataLoggerArchiveEntries.addCallbackFunction(thisClass.update);
    mainSite.timer.getDataLoggerArchiveEntries.oneShot();
    mainSite.timer.getDataLoggerArchiveEntries.resetTimeout();
  }

  this.update = function() {
    if (thisClass.visible) {
      //update data in site
      for (var i = 0; i < thisClass.dataBindings.length; i++) {
        thisClass.dataBindings[i]();
      }
    }
  };
}
DataLoggerPage.prototype = new PageTemplate();
DataLoggerPage.prototype.constructor = DataLoggerPage;
/*
 * ##################################################### End DataLoggerPage #####################################################
 */
/*###################################################### www/web/DataLogger.js #############################################*/
/*###################################################### www/web/KnxIpProxy.js #############################################*/
/*
 * ##################################################### Start KnxIpProxyPage #####################################################
 */
function KnxIpProxyPage() {
  this.serviceStatusKnxIpProxy = {
    status: ''
  }
  this.knxIpProxyStatus = undefined;
  this.knxIpProxyConfig = undefined;

  if (!(this instanceof KnxIpProxyPage)) {
    return new KnxIpProxyPage();
  }
  PageTemplate.call(this);
  var thisClass = this;

  this.prepare = function() {
    IscWebService('setKeepAlive', '', function(response) {});
    if (!thisClass.contentSection) {
      thisClass.contentSection = document.createElement('div');
      var header = document.createElement('h3');
      header.setAttribute('class', 'h3');
      header.appendChild(document.createTextNode(i18n.translate('knx_group_communication_proxy')));
      thisClass.contentSection.appendChild(header);
      var controlServiceButton = document.createElement('button');
      controlServiceButton.setAttribute('class', 'button--xsm');
      controlServiceButton.setAttribute('id', 'start_service');
      var controlServiceButtonText = document.createTextNode(i18n.translate('start_service'));
      controlServiceButton.appendChild(controlServiceButtonText);

      thisClass.contentSection.appendChild(controlServiceButton);
      thisClass.contentSection.appendChild(document.createElement('br'));
      var textServiceIs = document.createTextNode(i18n.translate('service_is'));
      thisClass.contentSection.appendChild(textServiceIs);
      thisClass.contentSection.appendChild(document.createTextNode(' '));
      var spanServiceStatus = document.createElement('span');
      spanServiceStatus.setAttribute('class', 'text--error');
      var spanServiceStatusText = document.createTextNode(i18n.translate('not_running'));
      spanServiceStatus.appendChild(spanServiceStatusText);
      thisClass.contentSection.appendChild(spanServiceStatus);
      thisClass.contentSection.appendChild(document.createTextNode('.'));

      thisClass.dataBindings.push(function() {
        if (thisClass.serviceStatusKnxIpProxy) {
          if (thisClass.serviceStatusKnxIpProxy.status == 'enabled / running') {
            controlServiceButtonText.nodeValue = i18n.translate('stop_service');
            spanServiceStatusText.nodeValue = i18n.translate('running');
            spanServiceStatus.setAttribute('class', 'text--success');
            thisClass.enableUpdateKnxIpProxyStatus(true);
          } else if (/^.*(failure|stopped)/gi.test(thisClass.serviceStatusKnxIpProxy.status)) {
            controlServiceButtonText.nodeValue = i18n.translate('start_service');
            spanServiceStatusText.nodeValue = i18n.translate('not_running');
            spanServiceStatus.setAttribute('class', 'text--error');
            thisClass.enableUpdateKnxIpProxyStatus(false);
          }
        }
      });

      controlServiceButton.onclick = function() {
        controlServiceButton.setAttribute('disabled', true);
        var controls = ['enable', 'start'];
        if (thisClass.serviceStatusKnxIpProxy.status == 'enabled / running') {
          controls = ['disable', 'stop'];
        }
        IscWebService('setService', {
          name: 'SdaKnxIpProxy',
          control: controls[0]
        }, function() {
          IscWebService('setService', {
            name: 'SdaKnxIpProxy',
            control: controls[1]
          }, function(response) {
            controlServiceButton.removeAttribute('disabled');
            if (response && response.error && response.id != '213') {
              return;
            }
            if (response.data && response.data.status == 'enabled / running') {
              controlServiceButton.setAttribute('id', 'stop_service');
              controlServiceButtonText.value = i18n.translate('stop_service');
              thisClass.enableUpdateKnxIpProxyStatus(true);
            } else {
              controlServiceButton.setAttribute('id', 'start_service');
              controlServiceButtonText.value = i18n.translate('start_service');
              thisClass.enableUpdateKnxIpProxyStatus(false);
            }
            thisClass.setServiceSdaKnxIpProxy({
              data: {
                status: (controls[1] == 'start' && response.data.status == 'done' ? 'enabled / running' : 'disabled / stopped')
              }
            });
            thisClass.update();
          });
        });
      };

      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createElement('br'));

      var formKnxIpProxy = document.createElement('form');
      formKnxIpProxy.setAttribute('class', 'narrow');

      var pUsername = document.createElement('p');
      var labelUsername = document.createElement('label');
      labelUsername.setAttribute('id', 'translate_username');
      labelUsername.setAttribute('for', 'username');
      labelUsername.appendChild(document.createTextNode(i18n.translate('username')));
      pUsername.appendChild(labelUsername);
      var inputUsername = document.createElement('input');
      inputUsername.setAttribute('type', 'text');
      inputUsername.setAttribute('id', 'username');
      inputUsername.setAttribute('maxlength', '30');
      inputUsername.setAttribute('autofocus', '');
      inputUsername.setAttribute('required', '');
      pUsername.appendChild(inputUsername);
      formKnxIpProxy.appendChild(pUsername);

      thisClass.setFocus = function() {
        inputUsername.focus();
      }

      var pPassword = document.createElement('p');
      var labelPassword = document.createElement('label');
      labelPassword.setAttribute('id', 'translate_password');
      labelPassword.setAttribute('for', 'password');
      labelPassword.appendChild(document.createTextNode(i18n.translate('password')));
      pPassword.appendChild(labelPassword);
      var inputPassword = document.createElement('input');
      inputPassword.setAttribute('type', 'password');
      inputPassword.setAttribute('id', 'password');
      inputPassword.setAttribute('maxlength', '40');
      inputPassword.setAttribute('required', '');
      pPassword.appendChild(inputPassword);
      formKnxIpProxy.appendChild(pPassword);

      var pConnectorMode = document.createElement('p');
      var labelConnectorMode = document.createElement('label');
      labelConnectorMode.setAttribute('id', 'translate_connector_mode');
      labelConnectorMode.setAttribute('for', 'connector_mode');
      labelConnectorMode.appendChild(document.createTextNode(i18n.translate('connector_mode')));
      pConnectorMode.appendChild(labelConnectorMode);
      var selectConnectorMode = document.createElement('select');
      selectConnectorMode.setAttribute('id', 'connector_mode');
      selectConnectorMode.setAttribute('required', '');
      var optionRouting = document.createElement('option');
      optionRouting.setAttribute('value', 'Routing');
      optionRouting.appendChild(document.createTextNode(i18n.translate('routing_mode')));
      selectConnectorMode.appendChild(optionRouting);
      var optionTunneling = document.createElement('option');
      optionTunneling.setAttribute('value', 'Tunneling');
      optionTunneling.appendChild(document.createTextNode(i18n.translate('tunneling_mode')));
      selectConnectorMode.appendChild(optionTunneling);
      var optionTunnelingWithIA = document.createElement('option');
      optionTunnelingWithIA.setAttribute('value', 'TunnelingWithIA');
      optionTunnelingWithIA.appendChild(document.createTextNode(i18n.translate('tunnelingia_mode')));
      selectConnectorMode.appendChild(optionTunnelingWithIA);
      pConnectorMode.appendChild(selectConnectorMode);
      formKnxIpProxy.appendChild(pConnectorMode);

      var pMulticastAddress = document.createElement('p');
      var pMulticastPort = document.createElement('p');

      selectConnectorMode.onchange = function() {
        if (selectConnectorMode.value == 'Routing') {
          pMulticastAddress.removeAttribute('hidden', '');
          pMulticastPort.removeAttribute('hidden', '');
        } else {
          pMulticastAddress.setAttribute('hidden', '');
          pMulticastPort.setAttribute('hidden', '');
        }
      }

      var labelMulticastAddress = document.createElement('label');
      labelMulticastAddress.setAttribute('for', 'knxIpMulticastAddress');
      labelMulticastAddress.appendChild(document.createTextNode(i18n.translate('multicast_address')));
      pMulticastAddress.appendChild(labelMulticastAddress);
      var inputMulticastAddress = document.createElement('input');
      inputMulticastAddress.setAttribute('type', 'text');
      inputMulticastAddress.setAttribute('id', 'knxIpMulticastAddress');
      inputMulticastAddress.setAttribute('maxlength', '15');
      inputMulticastAddress.setAttribute('pattern', '^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$');
      inputMulticastAddress.value = '224.0.23.12';
      pMulticastAddress.appendChild(inputMulticastAddress);
      formKnxIpProxy.appendChild(pMulticastAddress);

      var labelMulticastPort = document.createElement('label');
      labelMulticastPort.setAttribute('for', 'knxIpPort');
      labelMulticastPort.appendChild(document.createTextNode(i18n.translate('multicast_port')));
      pMulticastPort.appendChild(labelMulticastPort);
      var inputMulticastPort = document.createElement('input');
      inputMulticastPort.setAttribute('type', 'number');
      inputMulticastPort.setAttribute('id', 'knxIpPort');
      inputMulticastPort.setAttribute('min', '0');
      inputMulticastPort.setAttribute('max', '65535');
      inputMulticastPort.setAttribute('step', '1');
      inputMulticastPort.setAttribute('maxlength', '5');
      inputMulticastPort.setAttribute('pattern', '[0-9]+');
      inputMulticastPort.setAttribute('required', '');
      inputMulticastPort.value = '3671';
      pMulticastPort.appendChild(inputMulticastPort);
      formKnxIpProxy.appendChild(pMulticastPort);

      var connectors = document.createElement('fieldset');

      var headerConnectorIDs = document.createElement('legend');
      headerConnectorIDs.appendChild(document.createTextNode(i18n.translate('connector_ids')));
      connectors.appendChild(headerConnectorIDs);
      var connectorIdsInputs = [];
      var connectorInfos = [];
      for (var i = 0; i < 8; i++) {
        var connector = document.createElement('p');
        connectorIdsInputs.push(document.createElement('input'));
        connectorIdsInputs[i].setAttribute('pattern', '[A-Za-z0-9]{2}-?[A-Za-z0-9]{8}-?[A-Za-z0-9]{8}-?[A-Za-z0-9]{2}');
        connectorIdsInputs[i].setAttribute('type', 'text');
        connectorIdsInputs[i].setAttribute('maxlength', '23');
        connectorInfos.push(document.createElement('div'));
        connectorInfos[i].appendChild(document.createTextNode(''));
        connector.appendChild(connectorIdsInputs[i]);
        connector.appendChild(connectorInfos[i]);
        connectors.appendChild(connector);
      }

      thisClass.dataBindings.push(function() {
        for (var i = 0; i < connectorInfos.length; i++) {
          connectorInfos[i].firstChild.nodeValue = '';
        }
        if (thisClass.knxIpProxyStatus) {
          if (thisClass.knxIpProxyStatus.error) {
            if (thisClass.visible) new ModalConfirmDialogOk(i18n.translate('knx_group_communication_proxy'), i18n.translate('not_reachable')).prepare();
            return;
          }
          var data = thisClass.knxIpProxyStatus;
          if (data.ProxyStates != []) {
            var proxyStates = data.ProxyStates;
            for (var i = 0; i < proxyStates.length; i++) {
              var proxyState = proxyStates[i];
              var x = i;
              for (var j = connectorIdsInputs.length - 1; j >= 0; j--) {
                if (connectorIdsInputs[j].value == proxyState.Id) {
                  x = j;
                }
              }
              var connectorIDtxt = connectorIdsInputs[x];
              if (!connectorIDtxt.value) {
                if (document.activeElement === connectorIDtxt) {
                  for (var j = connectorIdsInputs.length - 1; j >= 0; j--) {
                    if (!connectorIdsInputs[j].value && document.activeElement !== connectorIdsInputs[j]) {
                      var connectorInfo = connectorInfos[j];
                      connectorInfos[i].firstChild.nodeValue = '';
                      x = j;
                    }
                  }
                }
                connectorIdsInputs[x].value = proxyState.Id;
              }
              var statusText = ' ';
              var connectorInfo = connectorInfos[x];
              connectorInfo.firstChild.nodeValue = '';
              var lastConnectTryTimestamp = '';
              if (proxyState.LastConnectTryTimestamp != 'not-a-date-time') {
                var getDateOrder = proxyState.LastConnectTryTimestamp.replace(/(\d{4})-([a-zA-Z]{3})-(\d{2}) (\d{2}):(\d{2}):(\d{2})/, '$3 $2 $1 $4:$5:$6 UTC');
                var lastConnectTryTimestampDateUTC = new Date(getDateOrder);
                lastConnectTryTimestamp = lastConnectTryTimestampDateUTC.toString().replace(/ GMT.*/g, '');
              }
              if (proxyState.State == 'Connected') {
                var translationTextId = lastConnectTryTimestamp !== '' ? 'connected' : 'connected_wo_timestamp';
                statusText += i18n.translate(translationTextId).replace('LASTCONNECTTRYTIMESTAMP', lastConnectTryTimestamp);
                connectorInfo.setAttribute('class', 'text--success');
              } else if (proxyState.State == 'LoopDetected') {
                statusText += i18n.translate('loop_detected');
                connectorInfo.setAttribute('class', 'text--error');
              } else if (proxyState.State == 'NotConnected') {
                var translationTextId = lastConnectTryTimestamp !== '' ? 'not_connected' : 'not_connected_wo_timestamp';
                statusText += i18n.translate(translationTextId).replace(/LASTCONNECTTRYTIMESTAMP|LASTCONNECTRESULTINFO|LASTCONNECTRESULT/gi,
                  function(subst) {
                    switch (subst) {
                      case 'LASTCONNECTTRYTIMESTAMP':
                        return lastConnectTryTimestamp;
                      case 'LASTCONNECTRESULTINFO':
                        return proxyState.LastConnectResultInfo;
                      case 'LASTCONNECTRESULT':
                        return proxyState.LastConnectResult;
                    }
                  });
                connectorInfo.setAttribute('class', 'text--error');
              }
              if (proxyState.State != 'NotConnected' && proxyState.TelegramCounter) {
                statusText += ' ' + proxyState.TelegramCounter + i18n.translate('knx_telegrams_routed');
              }
              connectorInfo.firstChild.nodeValue = statusText;
            }
          }
          controlServiceButtonText.nodeValue = i18n.translate('stop_service');
          spanServiceStatusText.nodeValue = i18n.translate('running');
          spanServiceStatus.setAttribute('class', 'text--success');
        }
        isKnxIpProxyStatusPending = false;
      });

      thisClass.dataBindings.push(function() {
        if (thisClass.serviceStatusKnxIpProxy) {
          if (thisClass.serviceStatusKnxIpProxy.status == 'disabled / stopped') {
            for (var i = 0; i < connectorInfos.length; i++) {
              connectorInfos[i].firstChild.nodeValue = '';
            }
          }
        }
      });

      formKnxIpProxy.appendChild(connectors);

      var pButtonSubmit = document.createElement('p');
      var buttonSubmit = document.createElement('button');
      buttonSubmit.setAttribute('type', 'submit');
      buttonSubmit.setAttribute('class', 'button--xsm');
      buttonSubmit.setAttribute('id', 'translate_submit');
      buttonSubmit.appendChild(document.createTextNode(i18n.translate('submit')));
      formKnxIpProxy.onsubmit = function(event) {
        event.preventDefault();
        if (event.target.checkValidity()) {
          thisClass.enableUpdateKnxIpProxyStatus(false);
          var usernameVal = inputUsername.value;
          var passwordVal = inputPassword.value;
          var multicastAdressVal = inputMulticastAddress.value;
          var portVal = inputMulticastPort.value;
          var connecterMode = selectConnectorMode.value;
          var sdaConnectorsVal = [];
          for (var i = 0; i < connectorIdsInputs.length; i++) {
            if (connectorIdsInputs[i].value) {
              sdaConnectorsVal.push({
                id: connectorIdsInputs[i].value
              });
            }
            var connectorInfo = connectorInfos[i];
            connectorInfo.firstChild.nodeValue = '';
          }
          buttonSubmit.setAttribute('disabled', true);
          mainSite.timer.getKnxIpProxyStatus.abortTimeout();
          IscWebService('writeKnxIpProxyConfig', {
            username: usernameVal,
            password: btoa(passwordVal),
            mode: connecterMode,
            knxIpMulticastAddress: multicastAdressVal,
            knxIpPort: portVal,
            sdaConnectors: sdaConnectorsVal
          }, function handleWriteSdaKnxIpProxyConfigResponse(response) {
            buttonSubmit.removeAttribute('disabled');
            if (response && !response.error) {
              if (thisClass.visible) new ModalConfirmDialogOk(i18n.translate('knx_group_communication_proxy'), i18n.translate('saved')).prepare();
              mainSite.timer.ReadKnxIpProxyConfig.oneShot();
              setTimeout(function() {
                mainSite.timer.getKnxIpProxyStatus.resetTimeout();
              }, 1000);
            }
            mainSite.timer.getKnxIpProxyStatus.resetTimeout();
          });
        }

      };
      pButtonSubmit.appendChild(buttonSubmit);
      formKnxIpProxy.appendChild(pButtonSubmit);
      thisClass.contentSection.appendChild(formKnxIpProxy);

      thisClass.readKnxIpProxyConfig = function() {
        if (thisClass.knxIpProxyConfig == undefined) {
          return;
        }
        var data = thisClass.knxIpProxyConfig;
        inputUsername.value = data.username;
        inputPassword.value = '';
        inputMulticastAddress.value = data.knxIpMulticastAddress;
        inputMulticastPort.value = data.knxIpPort;
        selectConnectorMode.value = data.mode;
        selectConnectorMode.onchange();
        var sdaConnectors = data.sdaConnectors;
        for (var i = 0; i < sdaConnectors.length; i++) {
          var connectorID = sdaConnectors[i].id;
          var x = i;
          for (var j = 0; j < connectorIdsInputs.length; j++) {
            if (connectorIdsInputs[j].value == connectorID)
              x = j;
          }
          var connectorIDtxt = connectorIdsInputs[x];
          if (!connectorIDtxt.value)
            connectorIDtxt.value = connectorID;
          var connectorInfo = connectorInfos[x];
          connectorInfo.firstChild.nodeValue = '';
        }
      };
    }
    mainSite.main.appendChild(thisClass.contentSection);
    thisClass.requestData();
    thisClass.update();
    thisClass.setFocus();
  };
  this.setFocus = undefined;
  this.setServiceSdaKnxIpProxy = function(response) {
    if (response && response.data) {
      thisClass.serviceStatusKnxIpProxy = response.data;
    }
    if (response && response.error && response.id == '213') {
      thisClass.serviceStatusKnxIpProxy = {
        status: ''
      }
    }
  }
  this.enableUpdateKnxIpProxyStatus = function(enabled) {
    if (enabled && mainSite.timer.getKnxIpProxyStatus.timeout == INTERVAL.NONE) {
      mainSite.timer.getKnxIpProxyStatus.timeout = INTERVAL.TENSECONDS;
      mainSite.timer.getKnxIpProxyStatus.oneShot();
      mainSite.timer.getKnxIpProxyStatus.resetTimeout();
    }
    if (!enabled) {
      mainSite.timer.getKnxIpProxyStatus.abortTimeout();
      mainSite.timer.getKnxIpProxyStatus.timeout = INTERVAL.NONE
      thisClass.knxIpProxyStatus = undefined;
    }
  }
  this.setKnxIpProxyStatus = function(response) {
    if (response && response.data) {
      thisClass.knxIpProxyStatus = response.data;
    }
  }

  this.setKnxIpProxyConfig = function(response) {
    if (response == undefined) {
      return;
    }
    if (response.error && response.id != ERROR_ID.ENCRYPTION_EXPCTED) {
      if (thisClass.visible) new ModalConfirmDialogOk(i18n.translate('knx_group_communication_proxy'), i18n.translate('config_error_failed_read')).prepare();
      return;
    }
    thisClass.knxIpProxyConfig = response.data;
  }
  this.readKnxIpProxyConfig = undefined;

  this.requestData = function() {
    mainSite.timer.getDeviceInfo.oneShot();
    if (!mainSite.timer.ReadKnxIpProxyConfig) {
      mainSite.timer.ReadKnxIpProxyConfig = new TimedRequest(INTERVAL.NONE, 'readKnxIpProxyConfig', '', thisClass.setKnxIpProxyConfig, thisClass);
    } else {
      mainSite.timer.ReadKnxIpProxyConfig.timeout = INTERVAL.NONE;
    }
    mainSite.timer.ReadKnxIpProxyConfig.addCallbackFunction(thisClass.readKnxIpProxyConfig);
    mainSite.timer.ReadKnxIpProxyConfig.oneShot();

    if (!mainSite.timer.setServiceSdaKnxIpProxy) {
      mainSite.timer.setServiceSdaKnxIpProxy = new TimedRequest(INTERVAL.TENSECONDS, 'setService', {
        name: 'SdaKnxIpProxy',
        control: 'status'
      }, thisClass.setServiceSdaKnxIpProxy, thisClass);
    } else {
      mainSite.timer.setServiceSdaKnxIpProxy.timeout = INTERVAL.TENSECONDS;
    }
    mainSite.timer.setServiceSdaKnxIpProxy.addCallbackFunction(thisClass.update);
    mainSite.timer.setServiceSdaKnxIpProxy.oneShot();
    mainSite.timer.setServiceSdaKnxIpProxy.resetTimeout();

    if (!mainSite.timer.getKnxIpProxyStatus) {
      mainSite.timer.getKnxIpProxyStatus = new TimedRequest(INTERVAL.TENSECONDS, 'getKnxIpProxyStatus', '', thisClass.setKnxIpProxyStatus, thisClass);
    } else {
      mainSite.timer.getKnxIpProxyStatus.timeout = INTERVAL.TENSECONDS;
    }
    mainSite.timer.getKnxIpProxyStatus.addCallbackFunction(thisClass.update);
    mainSite.timer.getKnxIpProxyStatus.oneShot();
    mainSite.timer.getKnxIpProxyStatus.resetTimeout();
  };

  this.update = function() {
    if (thisClass.visible) {
      //update data in site
      for (var i = 0; i < thisClass.dataBindings.length; i++) {
        thisClass.dataBindings[i]();
      }
    }
  };
}
KnxIpProxyPage.prototype = new PageTemplate();
KnxIpProxyPage.prototype.constructor = KnxIpProxyPage;
/*
 * ##################################################### End KnxIpProxyPage #####################################################
 *//*###################################################### www/web/KnxIpProxy.js #############################################*/
